diff -Narup Mtd-orig/fs/jffs2/compr.c mtd/fs/jffs2/compr.c
--- Mtd-orig/fs/jffs2/compr.c	2005-11-08 02:02:14.000000000 +0100
+++ mtd/fs/jffs2/compr.c	2005-11-29 16:24:04.000000000 +0100
@@ -1,457 +1,601 @@
-/*
- * JFFS2 -- Journalling Flash File System, Version 2.
- *
- * Copyright (C) 2001-2003 Red Hat, Inc.
- * Created by Arjan van de Ven <arjanv@redhat.com>
- *
- * Copyright (C) 2004 Ferenc Havasi <havasi@inf.u-szeged.hu>,
- *                    University of Szeged, Hungary
- *
- * For licensing information, see the file 'LICENCE' in this directory.
- *
- * $Id: compr.c,v 1.46 2005/11/07 11:14:38 gleixner Exp $
- *
- */
+#include <linux/crypto.h>
+#include <linux/rwsem.h>
+#include <linux/string.h>
+#include <linux/types.h>
+#include <linux/slab.h>
+#include <linux/vmalloc.h>
 
 #include "compr.h"
 
-static DEFINE_SPINLOCK(jffs2_compressor_list_lock);
+/* TODO: ctx->tree_lock is not used yet. it will be needed if once we implement a tree
+recreation function, for changing it on-the-fly. for this we need to get the new control
+string somehow first, for eg. through a procfs or a sysfs entry. */
+
+/* using caches for better memory organization & debugging aid */
+static kmem_cache_t *ctx_cache = NULL;
+static kmem_cache_t *tree_cache = NULL;
+static kmem_cache_t *crypto_cache = NULL;
+
+/* write locked when a new context is being created or destroyed, read locked in other
+functions */
+static struct rw_semaphore ctx_lock;
+
+int jffs2_init_compr_engine(void)
+{
+	int ret = 0;
+	init_rwsem(&ctx_lock);
+
+	ctx_cache = kmem_cache_create("compress_ctx", sizeof(struct compress_ctx),
+										0, SLAB_HWCACHE_ALIGN, NULL, NULL);
+	if (unlikely(!ctx_cache)) {
+		ret = -ENOMEM;
+		goto out;
+	}
+
+	crypto_cache = kmem_cache_create("cryptolist_entry", sizeof(struct cryptolist_entry),
+										   0, SLAB_HWCACHE_ALIGN, NULL, NULL);
+	if (unlikely(!crypto_cache)) {
+		kmem_cache_destroy(ctx_cache);
+		ret = -ENOMEM;
+		goto out;
+	}
+
+	tree_cache = kmem_cache_create("compresstree_node", sizeof(struct compresstree_node),
+										 0, SLAB_HWCACHE_ALIGN, NULL, NULL);
+	if (unlikely(!tree_cache)) {
+		kmem_cache_destroy(ctx_cache);
+		kmem_cache_destroy(tree_cache);
+		ret = -ENOMEM;
+	}
+ out:
+	return ret;
+}
+
+void jffs2_exit_compr_engine()
+{
+	if (ctx_cache)
+		kmem_cache_destroy(ctx_cache);
+	if (crypto_cache)
+		kmem_cache_destroy(crypto_cache);
+	if (tree_cache)
+		kmem_cache_destroy(tree_cache);
+}
+
+static int jffs2_create_crypto_alg(struct compress_ctx *ctx, struct cryptolist_entry **walk, char *alg_name)
+{
+	*walk = (struct cryptolist_entry *) kmem_cache_alloc(crypto_cache, GFP_KERNEL);
+	if (!(*walk))
+		return -ENOMEM;
+	memset(*walk, 0, sizeof(struct cryptolist_entry));
+
+	(*walk)->sess = crypto_alloc_tfm(alg_name, 0);
+	if (unlikely(!(*walk)->sess)) {
+		kmem_cache_free(crypto_cache, *walk);
+		return -ENOMEM;
+	}
+
+	up_read(&ctx->crypto_lock);
+	down_write(&ctx->crypto_lock);
+
+	if (unlikely(!ctx->cryptolist_head))
+		ctx->cryptolist_head = *walk;
+	else
+		ctx->cryptolist_tail->next = *walk;
+
+	ctx->cryptolist_tail = *walk;
+	downgrade_write(&ctx->crypto_lock);
+
+	return 0;
+}
+
+/* called with ctx_lock read-locked and ctx->crypto_lock read-locked */
+static struct cryptolist_entry *crypto_compress_wrapper(struct compress_ctx *ctx,
+									char *alg_name, u8 *src, int32_t srclen,
+									u8 *dst, int32_t *dstlen)
+{
+	struct cryptolist_entry *ret = NULL;
+	struct cryptolist_entry *walk;
+	int temp, res;
+
+	temp = strlen(alg_name);
+	if (*dstlen < (temp + 1))
+		goto out;
+	strcpy(dst, alg_name);
+	dst += temp;
+	*dst = '\0';
+	dst++;
+	(*dstlen) -= temp;
+	(*dstlen)--;
+	walk = ctx->cryptolist_head;
+
+	while (walk && strcmp(alg_name, crypto_tfm_alg_name(walk->sess)))
+		walk = walk->next;
+	/* performance hit if a compressor is used first time but after this branch
+		prediction can help much */
+	if (unlikely(!walk)) {
+		res = jffs2_create_crypto_alg(ctx, &walk, alg_name);
+		if (res)
+			goto out;
+	}
+
+	switch (crypto_tfm_alg_type(walk->sess)) {
+		case CRYPTO_ALG_TYPE_CIPHER:
+			printk("%s: CHIPER algorithm type is not supported jet! \n",__FUNCTION__);
+			res = 1;
+			break;
+
+		case CRYPTO_ALG_TYPE_DIGEST:
+			printk("%s: DIGEST algorithm type is not supported jet! \n",__FUNCTION__);
+			res = 1;
+			break;
+
+		case CRYPTO_ALG_TYPE_COMPRESS:
+			res = crypto_comp_compress(walk->sess, src, srclen, dst, dstlen); 
+			break;
+
+		default:
+			printk("%s: unknown algorithm type! \n",__FUNCTION__);
+			res = 1;
+			break;
+	}
+
+	if (res)
+		goto out;
+
+	(*dstlen) += temp;
+	(*dstlen)++;
+	ret = walk;
+out:
+	return ret;
+}
+
+/* called with ctx_lock read-locked and ctx->crypto_lock read-locked */
+static struct cryptolist_entry *crypto_decompress_wrapper(struct compress_ctx *ctx,
+										u8 *src, int32_t srclen, u8 *dst, int32_t *dstlen)
+{
+	struct cryptolist_entry *ret = NULL;
+	struct cryptolist_entry *walk;
+	int temp = 0, res;
+	char *alg_name = (char *) src;
+
+	while (*src) {
+		src++;
+		srclen--;
+		temp++;
+	}
+	src++;
+	srclen--;
+
+	walk = ctx->cryptolist_head;
+	while (walk && strcmp(alg_name, crypto_tfm_alg_name(walk->sess)))
+		walk = walk->next;
+	if (unlikely(!walk)) {
+		res = jffs2_create_crypto_alg(ctx, &walk, alg_name);
+		if (res)
+			goto out;
+	}
+
+	switch (crypto_tfm_alg_type(walk->sess)) {
+		case CRYPTO_ALG_TYPE_CIPHER:
+			printk("%s: CHIPER algorithm type is not supported jet! \n",__FUNCTION__);
+			res = 1;
+			break;
+
+		case CRYPTO_ALG_TYPE_DIGEST:
+			printk("%s: DIGEST algorithm type is not supported jet! \n",__FUNCTION__);
+			res = 1;
+			break;
+
+		case CRYPTO_ALG_TYPE_COMPRESS:
+			res = crypto_comp_decompress(walk->sess, src, srclen, dst, dstlen);
+			break;
+
+		default:
+			printk("%s: unknown algorithm type! \n",__FUNCTION__);
+			res = 1;
+			break;
 
-/* Available compressors are on this list */
-static LIST_HEAD(jffs2_compressor_list);
+		
+	}
 
-/* Actual compression mode */
-static int jffs2_compression_mode = JFFS2_COMPR_MODE_PRIORITY;
+	if (!res)
+		ret = walk;
 
-/* Statistics for blocks stored without compression */
-static uint32_t none_stat_compr_blocks=0,none_stat_decompr_blocks=0,none_stat_compr_size=0;
-
-/* jffs2_compress:
- * @data: Pointer to uncompressed data
- * @cdata: Pointer to returned pointer to buffer for compressed data
- * @datalen: On entry, holds the amount of data available for compression.
- *	On exit, expected to hold the amount of data actually compressed.
- * @cdatalen: On entry, holds the amount of space available for compressed
- *	data. On exit, expected to hold the actual size of the compressed
- *	data.
- *
- * Returns: Lower byte to be stored with data indicating compression type used.
- * Zero is used to show that the data could not be compressed - the
- * compressed version was actually larger than the original.
- * Upper byte will be used later. (soon)
- *
- * If the cdata buffer isn't large enough to hold all the uncompressed data,
- * jffs2_compress should compress as much as will fit, and should set
- * *datalen accordingly to show the amount of data which were compressed.
- */
-uint16_t jffs2_compress(struct jffs2_sb_info *c, struct jffs2_inode_info *f,
-			     unsigned char *data_in, unsigned char **cpage_out,
-			     uint32_t *datalen, uint32_t *cdatalen)
-{
-	int ret = JFFS2_COMPR_NONE;
-        int compr_ret;
-        struct jffs2_compressor *this, *best=NULL;
-        unsigned char *output_buf = NULL, *tmp_buf;
-        uint32_t orig_slen, orig_dlen;
-        uint32_t best_slen=0, best_dlen=0;
-
-        switch (jffs2_compression_mode) {
-        case JFFS2_COMPR_MODE_NONE:
-                break;
-        case JFFS2_COMPR_MODE_PRIORITY:
-                output_buf = kmalloc(*cdatalen,GFP_KERNEL);
-                if (!output_buf) {
-                        printk(KERN_WARNING "JFFS2: No memory for compressor allocation. Compression failed.\n");
-                        goto out;
-                }
-                orig_slen = *datalen;
-                orig_dlen = *cdatalen;
-                spin_lock(&jffs2_compressor_list_lock);
-                list_for_each_entry(this, &jffs2_compressor_list, list) {
-                        /* Skip decompress-only backwards-compatibility and disabled modules */
-                        if ((!this->compress)||(this->disabled))
-                                continue;
-
-                        this->usecount++;
-                        spin_unlock(&jffs2_compressor_list_lock);
-                        *datalen  = orig_slen;
-                        *cdatalen = orig_dlen;
-                        compr_ret = this->compress(data_in, output_buf, datalen, cdatalen, NULL);
-                        spin_lock(&jffs2_compressor_list_lock);
-                        this->usecount--;
-                        if (!compr_ret) {
-                                ret = this->compr;
-                                this->stat_compr_blocks++;
-                                this->stat_compr_orig_size += *datalen;
-                                this->stat_compr_new_size  += *cdatalen;
-                                break;
-                        }
-                }
-                spin_unlock(&jffs2_compressor_list_lock);
-                if (ret == JFFS2_COMPR_NONE) kfree(output_buf);
-                break;
-        case JFFS2_COMPR_MODE_SIZE:
-                orig_slen = *datalen;
-                orig_dlen = *cdatalen;
-                spin_lock(&jffs2_compressor_list_lock);
-                list_for_each_entry(this, &jffs2_compressor_list, list) {
-                        /* Skip decompress-only backwards-compatibility and disabled modules */
-                        if ((!this->compress)||(this->disabled))
-                                continue;
-                        /* Allocating memory for output buffer if necessary */
-                        if ((this->compr_buf_size<orig_dlen)&&(this->compr_buf)) {
-                                spin_unlock(&jffs2_compressor_list_lock);
-                                kfree(this->compr_buf);
-                                spin_lock(&jffs2_compressor_list_lock);
-                                this->compr_buf_size=0;
-                                this->compr_buf=NULL;
-                        }
-                        if (!this->compr_buf) {
-                                spin_unlock(&jffs2_compressor_list_lock);
-                                tmp_buf = kmalloc(orig_dlen,GFP_KERNEL);
-                                spin_lock(&jffs2_compressor_list_lock);
-                                if (!tmp_buf) {
-                                        printk(KERN_WARNING "JFFS2: No memory for compressor allocation. (%d bytes)\n",orig_dlen);
-                                        continue;
-                                }
-                                else {
-                                        this->compr_buf = tmp_buf;
-                                        this->compr_buf_size = orig_dlen;
-                                }
-                        }
-                        this->usecount++;
-                        spin_unlock(&jffs2_compressor_list_lock);
-                        *datalen  = orig_slen;
-                        *cdatalen = orig_dlen;
-                        compr_ret = this->compress(data_in, this->compr_buf, datalen, cdatalen, NULL);
-                        spin_lock(&jffs2_compressor_list_lock);
-                        this->usecount--;
-                        if (!compr_ret) {
-                                if ((!best_dlen)||(best_dlen>*cdatalen)) {
-                                        best_dlen = *cdatalen;
-                                        best_slen = *datalen;
-                                        best = this;
-                                }
-                        }
-                }
-                if (best_dlen) {
-                        *cdatalen = best_dlen;
-                        *datalen  = best_slen;
-                        output_buf = best->compr_buf;
-                        best->compr_buf = NULL;
-                        best->compr_buf_size = 0;
-                        best->stat_compr_blocks++;
-                        best->stat_compr_orig_size += best_slen;
-                        best->stat_compr_new_size  += best_dlen;
-                        ret = best->compr;
-                }
-                spin_unlock(&jffs2_compressor_list_lock);
-                break;
-        default:
-                printk(KERN_ERR "JFFS2: unknow compression mode.\n");
-        }
  out:
-        if (ret == JFFS2_COMPR_NONE) {
-	        *cpage_out = data_in;
-	        *datalen = *cdatalen;
-                none_stat_compr_blocks++;
-                none_stat_compr_size += *datalen;
-        }
-        else {
-                *cpage_out = output_buf;
-        }
 	return ret;
 }
 
-int jffs2_decompress(struct jffs2_sb_info *c, struct jffs2_inode_info *f,
-		     uint16_t comprtype, unsigned char *cdata_in,
-		     unsigned char *data_out, uint32_t cdatalen, uint32_t datalen)
-{
-        struct jffs2_compressor *this;
-        int ret;
-
-	/* Older code had a bug where it would write non-zero 'usercompr'
-	   fields. Deal with it. */
-	if ((comprtype & 0xff) <= JFFS2_COMPR_ZLIB)
-		comprtype &= 0xff;
-
-	switch (comprtype & 0xff) {
-	case JFFS2_COMPR_NONE:
-		/* This should be special-cased elsewhere, but we might as well deal with it */
-		memcpy(data_out, cdata_in, datalen);
-                none_stat_decompr_blocks++;
-		break;
-	case JFFS2_COMPR_ZERO:
-		memset(data_out, 0, datalen);
-		break;
-	default:
-                spin_lock(&jffs2_compressor_list_lock);
-                list_for_each_entry(this, &jffs2_compressor_list, list) {
-                        if (comprtype == this->compr) {
-                                this->usecount++;
-                                spin_unlock(&jffs2_compressor_list_lock);
-                                ret = this->decompress(cdata_in, data_out, cdatalen, datalen, NULL);
-                                spin_lock(&jffs2_compressor_list_lock);
-                                if (ret) {
-                                        printk(KERN_WARNING "Decompressor \"%s\" returned %d\n", this->name, ret);
-                                }
-                                else {
-                                        this->stat_decompr_blocks++;
-                                }
-                                this->usecount--;
-                                spin_unlock(&jffs2_compressor_list_lock);
-                                return ret;
-                        }
-                }
-		printk(KERN_WARNING "JFFS2 compression type 0x%02x not available.\n", comprtype);
-                spin_unlock(&jffs2_compressor_list_lock);
-		return -EIO;
+static void destroy_tree(struct compresstree_node *what)
+{
+/* no need for locks as this is called from init_compress, before any locking or from
+the following destroy_compress, after it acquired a global write lock */
+	if (what->sib)
+		destroy_tree(what->sib);
+	if (what->fson)
+		destroy_tree(what->fson);
+	kfree(what->name);
+	kmem_cache_free(tree_cache, what);
+}
+
+int jffs2_destroy_compr_context(struct compress_ctx **ctx)
+{
+	down_write(&ctx_lock);
+	if (*ctx) {
+		struct cryptolist_entry *temp;
+		/* no need for locking as we have global exclusive lock */
+		destroy_tree((*ctx)->compresstree_root);
+		temp = (*ctx)->cryptolist_head;
+		while (temp) {
+			(*ctx)->cryptolist_head = (*ctx)->cryptolist_head->next;
+			crypto_free_tfm(temp->sess);
+			kmem_cache_free(crypto_cache, temp);
+			temp = (*ctx)->cryptolist_head;
+		}
+		kmem_cache_free(ctx_cache, *ctx);
+		*ctx = NULL;
 	}
+	up_write(&ctx_lock);
 	return 0;
 }
 
-int jffs2_register_compressor(struct jffs2_compressor *comp)
+struct compress_ctx *jffs2_create_compr_context(char *cnt)
 {
-        struct jffs2_compressor *this;
+	char *w, *w2, *scan, *c, *ccnt, end;
+	compressmode_t node_type = COMPRESSMODE_NORMAL;
+	int breakout, temp;
+	struct compresstree_node *nodetemp, *nodewalk;
+	struct compresstree_tail *tail, *tailtemp, *tailend;
+	struct compress_ctx *ret = NULL;
+
+	down_write(&ctx_lock);
+
+	ret = (struct compress_ctx *) kmem_cache_alloc(ctx_cache, GFP_KERNEL);
+	if (unlikely(!ret))
+		goto out;
+	memset(ret, 0, sizeof(struct compress_ctx));
+
+	init_rwsem(&ret->crypto_lock);
+	init_rwsem(&ret->tree_lock);
+
+	while (*cnt && ((*cnt == ',') || (*cnt == ' ') || (*cnt == '\t')))
+		cnt++;
+	temp = strlen(cnt);
+
+	ccnt = kmalloc(temp + 1, GFP_KERNEL);
+	if (unlikely(!ccnt))
+		goto was_error;
+	strcpy(ccnt, cnt);
+
+	while (temp && ((ccnt[temp - 1] == ',') || (ccnt[temp - 1] == ' ') ||
+		(ccnt[temp - 1] == '\t'))) {
+			ccnt[temp] = '\0';
+			temp--;
+	}
+	if (unlikely(!temp)) {
+		kfree(ccnt);
+		goto out; /* compression will be turned off */
+	}
 
-        if (!comp->name) {
-                printk(KERN_WARNING "NULL compressor name at registering JFFS2 compressor. Failed.\n");
-                return -1;
-        }
-        comp->compr_buf_size=0;
-        comp->compr_buf=NULL;
-        comp->usecount=0;
-        comp->stat_compr_orig_size=0;
-        comp->stat_compr_new_size=0;
-        comp->stat_compr_blocks=0;
-        comp->stat_decompr_blocks=0;
-        D1(printk(KERN_DEBUG "Registering JFFS2 compressor \"%s\"\n", comp->name));
-
-        spin_lock(&jffs2_compressor_list_lock);
-
-        list_for_each_entry(this, &jffs2_compressor_list, list) {
-                if (this->priority < comp->priority) {
-                        list_add(&comp->list, this->list.prev);
-                        goto out;
-                }
-        }
-        list_add_tail(&comp->list, &jffs2_compressor_list);
-out:
-        D2(list_for_each_entry(this, &jffs2_compressor_list, list) {
-                printk(KERN_DEBUG "Compressor \"%s\", prio %d\n", this->name, this->priority);
-        })
-
-        spin_unlock(&jffs2_compressor_list_lock);
-
-        return 0;
-}
-
-int jffs2_unregister_compressor(struct jffs2_compressor *comp)
-{
-        D2(struct jffs2_compressor *this;)
-
-        D1(printk(KERN_DEBUG "Unregistering JFFS2 compressor \"%s\"\n", comp->name));
-
-        spin_lock(&jffs2_compressor_list_lock);
-
-        if (comp->usecount) {
-                spin_unlock(&jffs2_compressor_list_lock);
-                printk(KERN_WARNING "JFFS2: Compressor modul is in use. Unregister failed.\n");
-                return -1;
-        }
-        list_del(&comp->list);
-
-        D2(list_for_each_entry(this, &jffs2_compressor_list, list) {
-                printk(KERN_DEBUG "Compressor \"%s\", prio %d\n", this->name, this->priority);
-        })
-        spin_unlock(&jffs2_compressor_list_lock);
-        return 0;
-}
-
-#ifdef CONFIG_JFFS2_PROC
-
-#define JFFS2_STAT_BUF_SIZE 16000
-
-char *jffs2_list_compressors(void)
-{
-        struct jffs2_compressor *this;
-        char *buf, *act_buf;
-
-        act_buf = buf = kmalloc(JFFS2_STAT_BUF_SIZE,GFP_KERNEL);
-        list_for_each_entry(this, &jffs2_compressor_list, list) {
-                act_buf += sprintf(act_buf, "%10s priority:%d ", this->name, this->priority);
-                if ((this->disabled)||(!this->compress))
-                        act_buf += sprintf(act_buf,"disabled");
-                else
-                        act_buf += sprintf(act_buf,"enabled");
-                act_buf += sprintf(act_buf,"\n");
-        }
-        return buf;
-}
-
-char *jffs2_stats(void)
-{
-        struct jffs2_compressor *this;
-        char *buf, *act_buf;
-
-        act_buf = buf = kmalloc(JFFS2_STAT_BUF_SIZE,GFP_KERNEL);
-
-        act_buf += sprintf(act_buf,"JFFS2 compressor statistics:\n");
-        act_buf += sprintf(act_buf,"%10s   ","none");
-        act_buf += sprintf(act_buf,"compr: %d blocks (%d)  decompr: %d blocks\n", none_stat_compr_blocks,
-                           none_stat_compr_size, none_stat_decompr_blocks);
-        spin_lock(&jffs2_compressor_list_lock);
-        list_for_each_entry(this, &jffs2_compressor_list, list) {
-                act_buf += sprintf(act_buf,"%10s ",this->name);
-                if ((this->disabled)||(!this->compress))
-                        act_buf += sprintf(act_buf,"- ");
-                else
-                        act_buf += sprintf(act_buf,"+ ");
-                act_buf += sprintf(act_buf,"compr: %d blocks (%d/%d)  decompr: %d blocks ", this->stat_compr_blocks,
-                                   this->stat_compr_new_size, this->stat_compr_orig_size,
-                                   this->stat_decompr_blocks);
-                act_buf += sprintf(act_buf,"\n");
-        }
-        spin_unlock(&jffs2_compressor_list_lock);
-
-        return buf;
-}
-
-char *jffs2_get_compression_mode_name(void)
-{
-        switch (jffs2_compression_mode) {
-        case JFFS2_COMPR_MODE_NONE:
-                return "none";
-        case JFFS2_COMPR_MODE_PRIORITY:
-                return "priority";
-        case JFFS2_COMPR_MODE_SIZE:
-                return "size";
-        }
-        return "unkown";
-}
-
-int jffs2_set_compression_mode_name(const char *name)
-{
-        if (!strcmp("none",name)) {
-                jffs2_compression_mode = JFFS2_COMPR_MODE_NONE;
-                return 0;
-        }
-        if (!strcmp("priority",name)) {
-                jffs2_compression_mode = JFFS2_COMPR_MODE_PRIORITY;
-                return 0;
-        }
-        if (!strcmp("size",name)) {
-                jffs2_compression_mode = JFFS2_COMPR_MODE_SIZE;
-                return 0;
-        }
-        return 1;
-}
-
-static int jffs2_compressor_Xable(const char *name, int disabled)
-{
-        struct jffs2_compressor *this;
-        spin_lock(&jffs2_compressor_list_lock);
-        list_for_each_entry(this, &jffs2_compressor_list, list) {
-                if (!strcmp(this->name, name)) {
-                        this->disabled = disabled;
-                        spin_unlock(&jffs2_compressor_list_lock);
-                        return 0;
-                }
-        }
-        spin_unlock(&jffs2_compressor_list_lock);
-        printk(KERN_WARNING "JFFS2: compressor %s not found.\n",name);
-        return 1;
-}
-
-int jffs2_enable_compressor_name(const char *name)
-{
-        return jffs2_compressor_Xable(name, 0);
-}
-
-int jffs2_disable_compressor_name(const char *name)
-{
-        return jffs2_compressor_Xable(name, 1);
-}
-
-int jffs2_set_compressor_priority(const char *name, int priority)
-{
-        struct jffs2_compressor *this,*comp;
-        spin_lock(&jffs2_compressor_list_lock);
-        list_for_each_entry(this, &jffs2_compressor_list, list) {
-                if (!strcmp(this->name, name)) {
-                        this->priority = priority;
-                        comp = this;
-                        goto reinsert;
-                }
-        }
-        spin_unlock(&jffs2_compressor_list_lock);
-        printk(KERN_WARNING "JFFS2: compressor %s not found.\n",name);
-        return 1;
-reinsert:
-        /* list is sorted in the order of priority, so if
-           we change it we have to reinsert it into the
-           good place */
-        list_del(&comp->list);
-        list_for_each_entry(this, &jffs2_compressor_list, list) {
-                if (this->priority < comp->priority) {
-                        list_add(&comp->list, this->list.prev);
-                        spin_unlock(&jffs2_compressor_list_lock);
-                        return 0;
-                }
-        }
-        list_add_tail(&comp->list, &jffs2_compressor_list);
-        spin_unlock(&jffs2_compressor_list_lock);
-        return 0;
-}
-
-#endif
-
-void jffs2_free_comprbuf(unsigned char *comprbuf, unsigned char *orig)
-{
-        if (orig != comprbuf)
-                kfree(comprbuf);
-}
-
-int jffs2_compressors_init(void)
-{
-/* Registering compressors */
-#ifdef CONFIG_JFFS2_ZLIB
-        jffs2_zlib_init();
-#endif
-#ifdef CONFIG_JFFS2_RTIME
-        jffs2_rtime_init();
-#endif
-#ifdef CONFIG_JFFS2_RUBIN
-        jffs2_rubinmips_init();
-        jffs2_dynrubin_init();
-#endif
-/* Setting default compression mode */
-#ifdef CONFIG_JFFS2_CMODE_NONE
-        jffs2_compression_mode = JFFS2_COMPR_MODE_NONE;
-        D1(printk(KERN_INFO "JFFS2: default compression mode: none\n");)
-#else
-#ifdef CONFIG_JFFS2_CMODE_SIZE
-        jffs2_compression_mode = JFFS2_COMPR_MODE_SIZE;
-        D1(printk(KERN_INFO "JFFS2: default compression mode: size\n");)
-#else
-        D1(printk(KERN_INFO "JFFS2: default compression mode: priority\n");)
-#endif
-#endif
-        return 0;
-}
-
-int jffs2_compressors_exit(void)
-{
-/* Unregistering compressors */
-#ifdef CONFIG_JFFS2_RUBIN
-        jffs2_dynrubin_exit();
-        jffs2_rubinmips_exit();
-#endif
-#ifdef CONFIG_JFFS2_RTIME
-        jffs2_rtime_exit();
-#endif
-#ifdef CONFIG_JFFS2_ZLIB
-        jffs2_zlib_exit();
-#endif
-        return 0;
+	tail = kmalloc(sizeof(struct compresstree_tail), GFP_KERNEL);
+	tailend = tail;
+	if (unlikely(!tail)) {
+		kfree(ccnt);
+		goto was_error;
+	}
+
+	tail->owner = NULL;
+	tail->next = NULL;
+	tail->tail = ccnt;
+
+	while (tail) {
+		w2 = w = tail->tail;
+		scan = NULL;
+		breakout = 0;
+		while (!breakout) {
+			switch (*w) {
+				case '{':
+				case '[':
+					if (unlikely(node_type != COMPRESSMODE_NORMAL))
+						goto was_error_clean;
+					if (unlikely(*w == '{')) {
+						node_type = COMPRESSMODE_BESTCOMPRESS;
+						end = '}';
+					} else
+					if (unlikely(*w == '[')) {
+						node_type = COMPRESSMODE_FIRSTCOMPRESS;
+						end = ']';
+					} else
+						end = '\0';
+					w++;
+					while (*w && ((*w == ',') || (*w == '\t') || (*w == ' ')))
+						w++;
+					w2 = w;
+					scan = w;
+					while (*scan && (*scan != end)) scan++;
+					if (*scan) scan++;
+					while (*scan && ((*scan == ',') || (*scan == '\t') || (*scan == ' ')))
+						scan++;
+					break;
+
+				case '\0':
+				case ' ':
+				case '\t':
+				case ',':
+				case '}':
+				case ']':
+					if (unlikely((*w == '}') && (node_type != COMPRESSMODE_BESTCOMPRESS)))
+						goto was_error_clean;
+					if (unlikely((*w == ']') && (node_type != COMPRESSMODE_FIRSTCOMPRESS)))
+						goto was_error_clean;
+					if (unlikely(w2 != w)) { /* to skip empty {} and [] */
+						c = kmalloc(w - w2 + 1, GFP_KERNEL);
+						if (unlikely(!c))
+							goto was_error_clean;
+						strncpy(c, w2, w - w2);
+						c[w - w2] = '\0';
+
+						nodetemp = kmem_cache_alloc(tree_cache, GFP_KERNEL);
+						if (unlikely(!nodetemp)) {
+							kfree(c);
+							goto was_error_clean;
+						}
+						nodetemp->dad = tail->owner;
+						nodetemp->sib = nodetemp->fson = NULL;
+						nodetemp->name = c;
+						nodetemp->node_type = node_type;
+						if (tail->owner) {
+							if (unlikely(!tail->owner->fson))
+								tail->owner->fson = nodetemp;
+							else {
+								nodewalk = tail->owner->fson;
+								while (nodewalk->sib)
+									nodewalk = nodewalk->sib;
+								nodewalk->sib = nodetemp;
+							}
+						} else
+							if (unlikely(!ret->compresstree_root))
+								ret->compresstree_root = nodetemp;
+							else {
+								nodewalk = ret->compresstree_root;
+								while (nodewalk->sib)
+									nodewalk = nodewalk->sib;
+								nodewalk->sib = nodetemp;
+							}
+						if (scan && *scan) {
+							tailtemp = kmalloc(sizeof(struct compresstree_tail), GFP_KERNEL);
+							if (unlikely(!tailtemp))
+								goto was_error_clean;
+
+							tailtemp->owner = nodetemp;
+							tailtemp->next = NULL;
+
+							tailtemp->tail = kmalloc(strlen(scan) + 1, GFP_KERNEL);
+							if (unlikely(!tailtemp->tail))
+								goto was_error_clean;
+							strcpy(tailtemp->tail, scan);
+							tailend->next = tailtemp;
+							tailend = tailtemp;
+						}
+						if (unlikely((*w == '}') || (*w == ']')))
+							node_type = COMPRESSMODE_NORMAL;
+						if (tail && ((node_type == COMPRESSMODE_NORMAL) || !*w)) {
+							scan = NULL;
+							tailtemp = tail;
+							tail = tail->next;
+							kfree(tailtemp->tail);
+							kfree(tailtemp);
+							breakout = 1;
+							break;
+						}
+					} else
+						node_type = COMPRESSMODE_NORMAL;
+					if (*w)
+						w++;
+					while (*w && ((*w == ',') || (*w == '\t') || (*w == ' ')))
+						w++;
+					w2 = w;
+					break;
+
+				default:
+					w++;
+					if (unlikely(!scan)) {
+						scan = w;
+						while (*scan && (*scan != ',') && (*scan != '\t') && (*scan != ' '))
+							scan++;
+						while (*scan && ((*scan == ',') || (*scan == '\t') || (*scan == ' ')))
+							scan++;
+					}
+			}
+		}
+	}
+	goto out;
+ was_error_clean:
+	destroy_tree(ret->compresstree_root);
+	while (tail) {
+		tailtemp = tail;
+		tail = tail->next;
+		kfree(tailtemp->tail);
+		kfree(tailtemp);
+	}
+ was_error:
+	kmem_cache_free(ctx_cache, ret);
+	ret = NULL;
+ out:
+	up_write(&ctx_lock);
+	return ret;
+}
+
+/* ctx is not modified but can be changed by a running destroy */
+int jffs2_compress(struct compress_ctx **ctx, u8 *src, int32_t srclen, u8 *dst, int32_t *dstlen)
+{
+	int ret = 0;
+	int32_t selectedlen = srclen;
+	u8 *selected;
+	struct compresstree_node *selwalk;
+	struct cryptolist_entry *currc, *selc = NULL;
+
+	down_read(&ctx_lock);
+	if (unlikely(!*ctx))
+		goto out;
+
+	selected = vmalloc(selectedlen);
+	if (unlikely(!selected)) {
+		ret = -1;
+		goto out;
+	}
+	memcpy(selected, src, selectedlen);
+	selwalk = (*ctx)->compresstree_root;
+
+	while (selwalk) {
+		u8 *best = NULL;
+		struct compresstree_node *walk = selwalk;
+		int32_t bestlen = 0;
+
+		down_read(&(*ctx)->crypto_lock);
+
+		while (walk) {
+			u8 *curr;
+			int32_t currlen = *dstlen;
+
+			curr = vmalloc(currlen);
+			if (unlikely(!curr)) {
+				vfree(selected);
+				ret = -1;
+				goto out_unlock;
+			}
+
+			currc = crypto_compress_wrapper(*ctx, walk->name, selected, selectedlen, curr, &currlen);
+			if (currc && (!bestlen || ((walk->node_type == COMPRESSMODE_BESTCOMPRESS) && (currlen < bestlen)))) {
+				if (bestlen)
+					vfree(best);
+				bestlen = currlen;
+				best = curr;
+				selwalk = walk;
+				selc = currc;
+			} else
+				vfree(curr);
+
+			if (walk->node_type == COMPRESSMODE_NORMAL || (walk->node_type == COMPRESSMODE_FIRSTCOMPRESS && currc))
+				break;
+
+			walk = walk->sib;
+		}
+
+		if (!bestlen || /*(selectedlen < bestlen)*/
+						(*dstlen < bestlen))
+			break;
+
+		vfree(selected);
+		selected = best;
+		/* compiler complains here but everything's ok. execution will reach this
+		point only if bestlen is set but that time selc is set, too. */
+		selc->tot_to_compress += selectedlen;
+		selc->tot_compressed += bestlen;
+		selc->compr_blocks++;
+		selectedlen = bestlen;
+		selwalk = selwalk->fson;
+		ret++;
+	}
+	if (likely(ret && (selectedlen <= *dstlen)))
+		memcpy(dst, selected, *dstlen = selectedlen);
+	else
+		ret = -1;
+	vfree(selected);
+
+ out_unlock:
+	up_read(&(*ctx)->crypto_lock);
+
+ out:
+	up_read(&ctx_lock);
+	return ret;
+}
+
+/* ctx is not modified but can be changed by a running destroy */
+int jffs2_decompress(struct compress_ctx **ctx, u8 *src, int32_t srclen, u8 *dst,
+					int32_t *dstlen, int compressors)
+{
+	int tmplen = srclen;
+	struct cryptolist_entry *currc;
+	int ret = 0;
+	u8 *tmp;
+
+	/* deny destroy while we are running */
+	down_read(&ctx_lock);
+	if (unlikely(!*ctx))
+		goto out;
+
+	tmp = vmalloc(tmplen);
+	if (unlikely(!tmp)) {
+		ret = -1;
+		goto out;
+	}
+	memcpy(tmp, src, tmplen);
+	/* just a read lock for concurrent decompress's and concurrent compress's. will be
+	converted to a write lock by crypto_[de]compress_wrapper, when needed */
+	down_read(&(*ctx)->crypto_lock);
+	while (compressors) {
+		u8 *tmp2 = tmp;
+		int slen = tmplen;
+
+		tmplen = *dstlen;
+		tmp = vmalloc(tmplen);
+		if (unlikely(!tmp)) {
+			ret = -1;
+			goto out;
+		}
+
+		currc = crypto_decompress_wrapper(*ctx, tmp2, slen, tmp, &tmplen);
+		if (!currc) {
+			vfree(tmp);
+			vfree(tmp2);
+			ret = -1;
+			goto out_unlock;
+		} else {
+			/* we have read lock but this is write. it's no matter when data is added to
+			the statistics. two concurrent updates don't make any trouble. the side effect
+			is that the statistics given by compress_stats are the live ones. but more
+			decompress's can run concurrently :-) */
+			currc->tot_to_decompress += slen;
+			currc->tot_decompressed += tmplen;
+			currc->decompr_blocks++;
+		}
+		vfree(tmp2);
+		compressors--;
+	}
+	memcpy(dst, tmp, *dstlen = tmplen);
+	vfree(tmp);
+ out_unlock:
+	up_read(&(*ctx)->crypto_lock);
+ out:
+	up_read(&ctx_lock);
+	return ret;
+}
+
+/* ctx is not modified but can be changed by a running destroy */
+char *jffs2_compr_stats(struct compress_ctx **ctx)
+{
+	struct cryptolist_entry *temp;
+	char *buf = NULL, *act_buf;
+	/* deny destroy while we are running */
+	down_read(&ctx_lock);
+	/* maybe a destroy has just exited */
+	if (likely(*ctx)) {
+		buf = kmalloc(JFFS2_STAT_BUF_SIZE, GFP_KERNEL);
+		act_buf = buf;
+		if (act_buf) {
+			act_buf += sprintf(act_buf, "Compressors:\n");
+			/* deny registering a new compressor */
+			down_read(&(*ctx)->crypto_lock);
+			temp = (*ctx)->cryptolist_head;
+			while (temp) {
+        		act_buf += sprintf(act_buf, "%10s compressed: %llu -> %llu, %llu blocks; decompressed: %llu -> %llu, %llu blocks\n",
+					crypto_tfm_alg_name(temp->sess), temp->tot_to_compress, temp->tot_compressed, temp->compr_blocks,
+					temp->tot_to_decompress, temp->tot_decompressed, temp->decompr_blocks);
+				temp = temp->next;
+			}
+			up_read(&(*ctx)->crypto_lock);
+		}
+	}
+	up_read(&ctx_lock);
+	return buf;
 }
